//  scanningdialog.h -- template and derived ESC/I ESC/I-2 protocol commands
//  Copyright (C) 2018-2019  SEIKO EPSON CORPORATION
//
//  License: GPL-3.0+
//  Author : SEIKO EPSON CORPORATION
//
//  This file is part of the 'Epson Scan 2' package.
//  This package is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License or, at
//  your option, any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//  You ought to have received a copy of the GNU General Public License
//  along with this package.  If not, see <http://www.gnu.org/licenses/>.

#ifndef SCANNINGDIALOG_H
#define SCANNINGDIALOG_H

#include <QDialog>
#include <QCloseEvent>
#include <QTimer>

#include "supervisor.h"

namespace Ui {
class ScanningDialog;
}

class ScanningDialog : public QDialog
{
    Q_OBJECT

public:
    explicit ScanningDialog(Supervisor* sv, QWidget *parent = 0);
    ~ScanningDialog();

    int getPagecount();

    void ScanInitialize(QString progress_message);

protected:
    void closeEvent(QCloseEvent* event);

private:
    Ui::ScanningDialog *ui;
    Supervisor *sv;
    int page_count;

    QTimer* m_timer;
    bool do_cancel;

private slots:
    void Update();
    void Cancel();
};

#endif // SCANNINGDIALOG_H
